% Natali Ruchansky
% Boston University Computer Science

% Greedy Post-Processing

% The input X is the cluster membership returned by nnls
% X(i) is not binary but non-negativ [0,1]

function [ resX,C ] = greedypp( S,Z,X, p ,cur, curDists)


k=length(X);
resX=zeros(k,1);

%Append indices to X
%Sort X in descending order
tempX=X;
[tempX, ind]=sort(tempX,'descend');
tempX(:,2)=ind;

%Random sample of elements to compare with
compwith=randi(n, 1, 50);

%Vary q from 1 to p and compute the cost of each Xq
for q=1:p
    sprintf('%s %d','greedypp loop',q)
    Xi=tempX;
    Xi(1:q,1)=1;
    Xi(q+1:k,1)=0;
%     Xi;
    sortedXi=sortrows(Xi,2);
    sortedXi=sortedXi(:,1);
    Xcosts(q)=labelCost(sortedXi,S, curDists, compwith);
end

%find the minimum cost and index (optimal p)
[minimum index]=min(Xcosts);
C=minimum;
for a=1:index
    resX(a)=1;
end

%reappended the shuffled indices and sort them back into order
tempX(:,1)=resX;
tempX=sortrows(tempX,2);
resX=tempX(:,1);

end

